package cn.com.yitong.ares.container;

import cn.com.yitong.ares.container.Container;
import cn.com.yitong.util.common.ClassHelper;
import cn.com.yitong.util.common.ConfigUtils;
import cn.com.yitong.util.common.SystemUtil;
import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.ReentrantLock;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class Launcher {

   private static Logger logger = LoggerFactory.getLogger(Launcher.class);
   private static final ReentrantLock a;
   private static final Condition a = (a = new ReentrantLock()).newCondition();
   private static Container a = null;
   public static final String CONTAINER_CLASS = "ares.container.class";
   public static final String DEFAULT_CONTAINER_CLASS = "cn.com.yitong.ares.container.JettyContainer";


   public static void main(String[] args) throws Exception {
      String launchClazz = ConfigUtils.getProperty("ares.container.class", "cn.com.yitong.ares.container.JettyContainer");
      logger.info("{}={}", "ares.container.class", launchClazz);
      String[] e;
      int var4 = (e = launchClazz.split(",|;")).length;

      for(int var5 = 0; var5 < var4; ++var5) {
         launcher(e[var5]);
      }

      try {
         a.lock();
         a.await();
         return;
      } catch (InterruptedException var10) {
         logger.error("service server stopped, interrupted by other thread!");
      } finally {
         a.unlock();
      }

   }

   public static void launcher(String launchClazz) throws Exception {
      Class clazz;
      a = (Container)(clazz = ClassHelper.forName(launchClazz)).newInstance();
      long startTime = System.currentTimeMillis();
      logger.info("\n\n启动 {} ...", clazz.getSimpleName());
      a.start();
      long time = (System.currentTimeMillis() - startTime) / 1000L;
      int PID = SystemUtil.getPID();
      logger.info("服务启动完成，耗时：{}秒，PID={}", Long.valueOf(time), Integer.valueOf(PID));
      Runtime.getRuntime().addShutdownHook(new Thread() {
         public final void run() {
            try {
               Launcher.a.lock();
               Launcher.a.signal();
               if(Launcher.a != null) {
                  Launcher.a.stop();
               }
            } finally {
               Launcher.a.unlock();
               Launcher.logger.info("服务停止完成!");
            }

         }
      });
   }

}
